Make sure the hostname doesn't contain the domain name. Added Slackare init and setup scripts.

Thu, 13 May 2021 13:49:04 +0200

author
Michiel Broek <mbroek@mbse.eu>
date
Thu, 13 May 2021 13:49:04 +0200
changeset 612
452f79a5ad71
parent 611
732d482f47c8
child 613
163fcb0914e2

Make sure the hostname doesn't contain the domain name. Added Slackare init and setup scripts.

thermferm/mqtt.c file | annotate | diff | comparison | revisions
tools/Makefile file | annotate | diff | comparison | revisions
tools/init.debian file | annotate | diff | comparison | revisions
tools/init.slackware file | annotate | diff | comparison | revisions
tools/setup.slackware file | annotate | diff | comparison | revisions
tools/thermferm.init file | annotate | diff | comparison | revisions
--- a/thermferm/mqtt.c	Wed May 12 21:17:59 2021 +0200
+++ b/thermferm/mqtt.c	Thu May 13 13:49:04 2021 +0200
@@ -1561,6 +1561,10 @@
      * Initialize mosquitto communication
      */
     gethostname(my_hostname, 255);
+    if (strchr(my_hostname, '.')) {
+	char *p = strchr(my_hostname, '.');
+	*p = '\0';
+    }
     mosquitto_lib_init();
     id = xstrcpy((char *)"thermferm/");
     id = xstrcat(id, my_hostname);
@@ -1580,9 +1584,6 @@
            case EINVAL:
                syslog(LOG_NOTICE, "MQTT: mosquitto_new: Invalid id");
                break;
-	   default:
-		syslog(LOG_NOTICE, "MQTT: mosquitto_new: Unknown error %d", errno);
-		break;
        }
        mosquitto_lib_cleanup();
        return;
@@ -1611,20 +1612,18 @@
     mosquitto_message_callback_set(mosq, my_message_callback);
     mosquitto_subscribe_callback_set(mosq, my_subscribe_callback);
 
-    if (Config.mqtt_username && Config.mqtt_password) {
-	syslog(LOG_NOTICE, "MQTT: mosquitto_username_pw_set(%s, %s)", Config.mqtt_username, Config.mqtt_password);
-	if ((rc = mosquitto_username_pw_set(mosq, Config.mqtt_username, Config.mqtt_password))) {
-	    switch(errno) {
-           	case ENOMEM:
-		    syslog(LOG_NOTICE, "MQTT: mosquitto_username_pw_set: Out of memory");
-               	    break;
-           	case EINVAL:
-		    syslog(LOG_NOTICE, "MQTT: mosquitto_username_pw_set: Invalid id");
-		    break;
-           	default:
-		    syslog(LOG_NOTICE, "MQTT: mosquitto_username_pw_set: Unknown error %d", errno);
-		    break;
-       	    }
+    if (Config.mqtt_username) {
+	if (Config.mqtt_password) {
+	    rc = mosquitto_username_pw_set(mosq, Config.mqtt_username, Config.mqtt_password);
+	} else {
+	    rc = mosquitto_username_pw_set(mosq, Config.mqtt_username, NULL);
+	}
+	if (rc == MOSQ_ERR_INVAL) {
+	    syslog(LOG_NOTICE, "MQTT: mosquitto_username_pw_set: Invalid id");
+	} else if (rc == MOSQ_ERR_NOMEM) {
+	    syslog(LOG_NOTICE, "MQTT: mosquitto_username_pw_set: Out of memory");
+	}
+	if (rc != MOSQ_ERR_SUCCESS) {
        	    mosquitto_lib_cleanup();
        	    return;
 	}
--- a/tools/Makefile	Wed May 12 21:17:59 2021 +0200
+++ b/tools/Makefile	Thu May 13 13:49:04 2021 +0200
@@ -2,12 +2,7 @@
 
 include ../Makefile.global
 
-#SRCS		= $(wildcard *.c)
-#HDRS		= $(wildcard *.h)
-#OBJS		= $(SRCS:.c=.o)
-#SLIBS		= -lpthread
-#TARGET		= thermferm
-OTHER		= Makefile thermferm.init
+OTHER		= Makefile init.debian init.slackware setup.slackware
 
 #############################################################################
 
@@ -21,8 +16,19 @@
 		rm -f ${TARGET} *.o *.h~ *.c~ core filelist Makefile.bak
 
 install:
-		${INSTALL} -c -g root -o root -m 0755 thermferm.init /etc/init.d/thermferm
-		[ -x /bin/systemctl ] && /bin/systemctl daemon-reload
+		@if [ -x /lib/systemd/systemd ]; then \
+			${INSTALL} -c -g root -o root -m 0755 init.debian /etc/init.d/thermferm ; \
+			echo "${INSTALL} -c -g root -o root -m 0755 init.debian /etc/init.d/thermferm" ; \
+			[ -x /bin/systemctl ] && /bin/systemctl daemon-reload ; \
+			echo "[ -x /bin/systemctl ] && /bin/systemctl daemon-reload" ; \
+		elif [ -f /etc/slackware-version ]; then \
+			${INSTALL} -c -g root -o root -m 0755 init.slackware /etc/rc.d/init.d/thermferm ; \
+			echo "${INSTALL} -c -g root -o root -m 0755 init.slackware /etc/rc.d/init.d/thermferm" ; \
+			${INSTALL} -c -g root -o root -m 0755 setup.slackware /var/lib/pkgtools/setup/setup.thermferm ; \
+			echo "${INSTALL} -c -g root -o root -m 0755 setup.slackware /var/lib/pkgtools/setup/setup.thermferm" ; \
+		else \
+			echo "Unsupported distribution" ; \
+		fi
 
 filelist:	Makefile
 		BASE=`pwd`; \
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/tools/init.debian	Thu May 13 13:49:04 2021 +0200
@@ -0,0 +1,156 @@
+#! /bin/sh
+### BEGIN INIT INFO
+# Provides:          thermferm
+# Required-Start:    $local_fs $remote_fs $network $syslog
+# Required-Stop:     $local_fs $remote_fs $network $syslog
+# Should-Start:      mosquitto
+# Should-Stop:       mosquitto
+# Default-Start:     2 3 4 5
+# Default-Stop:      0 1 6
+# Short-Description: Thermferm beer fermenter initscript
+# Description:       This program controls temperature controlled chambers
+#                    that are used to ferment beer.
+### END INIT INFO
+
+# Author: Michiel Broek <mbroek@mbse.eu>
+
+# Do NOT "set -e"
+
+# PATH should only include /usr/* if it runs after the mountnfs.sh script
+PATH=/sbin:/usr/sbin:/bin:/usr/bin
+DESC="MBSE thermferm"
+NAME=thermferm
+DAEMON=/usr/local/bin/$NAME
+#DAEMON_ARGS="--options args"
+PIDFILE=/run/$NAME.pid
+SCRIPTNAME=/etc/init.d/$NAME
+
+# Exit if the package is not installed
+[ -x "$DAEMON" ] || exit 0
+
+# Read configuration variable file if it is present
+[ -r /etc/default/$NAME ] && . /etc/default/$NAME
+
+# Load the VERBOSE setting and other rcS variables
+. /lib/init/vars.sh
+
+# Define LSB log_* functions.
+# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
+# and status_of_proc is working.
+. /lib/lsb/init-functions
+
+#
+# Function that starts the daemon/service
+#
+do_start()
+{
+	# Return
+	#   0 if daemon has been started
+	#   1 if daemon was already running
+	#   2 if daemon could not be started
+	#start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null || return 1
+	#start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- $DAEMON_ARGS || return 2
+	$DAEMON
+	# Add code here, if necessary, that waits for the process to be ready
+	# to handle requests from services started subsequently which depend
+	# on this one.  As a last resort, sleep for some time.
+}
+
+#
+# Function that stops the daemon/service
+#
+do_stop()
+{
+	# Return
+	#   0 if daemon has been stopped
+	#   1 if daemon was already stopped
+	#   2 if daemon could not be stopped
+	#   other if a failure occurred
+	start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
+	RETVAL="$?"
+	[ "$RETVAL" = 2 ] && return 2
+	# Wait for children to finish too if this is a daemon that forks
+	# and if the daemon is only ever run from this initscript.
+	# If the above conditions are not satisfied then add some other code
+	# that waits for the process to drop all resources that could be
+	# needed by services started subsequently.  A last resort is to
+	# sleep for some time.
+	start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
+	[ "$?" = 2 ] && return 2
+	# Many daemons don't delete their pidfiles when they exit.
+	rm -f $PIDFILE
+	return "$RETVAL"
+}
+
+#
+# Function that sends a SIGHUP to the daemon/service
+#
+do_reload() {
+	#
+	# If the daemon can reload its configuration without
+	# restarting (for example, when it is sent a SIGHUP),
+	# then implement that here.
+	#
+	start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
+	return 0
+}
+
+case "$1" in
+  start)
+	[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
+	do_start
+	case "$?" in
+		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+	esac
+	;;
+  stop)
+	[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
+	do_stop
+	case "$?" in
+		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+	esac
+	;;
+  status)
+	status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
+	;;
+  #reload|force-reload)
+	#
+	# If do_reload() is not implemented then leave this commented out
+	# and leave 'force-reload' as an alias for 'restart'.
+	#
+	#log_daemon_msg "Reloading $DESC" "$NAME"
+	#do_reload
+	#log_end_msg $?
+	#;;
+  restart|force-reload)
+	#
+	# If the "reload" option is implemented then remove the
+	# 'force-reload' alias
+	#
+	log_daemon_msg "Restarting $DESC" "$NAME"
+	do_stop
+	case "$?" in
+	  0|1)
+		do_start
+		case "$?" in
+			0) log_end_msg 0 ;;
+			1) log_end_msg 1 ;; # Old process is still running
+			*) log_end_msg 1 ;; # Failed to start
+		esac
+		;;
+	  *)
+		# Failed to stop
+		log_end_msg 1
+		;;
+	esac
+	;;
+  *)
+	#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
+	echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
+	exit 3
+	;;
+esac
+
+:
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/tools/init.slackware	Thu May 13 13:49:04 2021 +0200
@@ -0,0 +1,39 @@
+#!/bin/bash
+#
+# thermferm init script for Slackware.
+#
+# Copyright 2021 Michiel Broek, the Netherlands.
+
+PIDFILE=/var/run/thermferm.pid
+
+case "$1" in
+  start)
+    echo -n "Starting Fermentation Controller: "
+    if [ -f ${PIDFILE} ]; then
+  	echo "already running."
+    else
+	/usr/local/bin/thermferm
+        echo "done."
+    fi
+    ;;
+
+  stop)
+    echo -n "Stopping Fermentation Controller: "
+    if [ -f ${PIDFILE} ]; then
+      kill $(cat ${PIDFILE})
+      echo "done."
+    else
+      echo "wasn't running."
+    fi
+    ;;
+
+  restart)
+    $0 stop
+    sleep 1
+    $0 start
+    ;;
+
+  *)
+    echo "usage: $0 {start|stop|restart}"
+esac
+
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/tools/setup.slackware	Thu May 13 13:49:04 2021 +0200
@@ -0,0 +1,25 @@
+#!/bin/sh
+#BLURB="Enable/disable the Fermentation Controller at boot"
+#
+# System setup script for Slackware
+#
+#
+T_PX=$1
+TMP=/var/lib/pkgtools/setup/tmp
+if [ "$COLOR" = "on" -o -r $TMP/SeTcolor ]; then
+  dialog --title "ENABLE thermferm DAEMON AT BOOT?" --yesno \
+ "Thermferm is a brewery fermentation controller that controls \
+  fermenters temperatures. This is done by controlling cooling \
+  or heating. Comminucation to the upper level is done via an \
+  MQTT broker. For local maintenance there is a web interface." 10 70
+  if [ $? = 0 ]; then
+    mkdir -p /etc/rc.d/rc0.d /etc/rc.d/rc1.d /etc/rc.d/rc3.d /etc/rc.d/rc4.d /etc/rc.d/rc6
+    ln -s /etc/rc.d/init.d/thermferm /etc/rc.d/rc0.d/K14thermferm
+    ln -s /etc/rc.d/init.d/thermferm /etc/rc.d/rc1.d/K14thermferm
+    ln -s /etc/rc.d/init.d/thermferm /etc/rc.d/rc3.d/S86thermferm
+    ln -s /etc/rc.d/init.d/thermferm /etc/rc.d/rc4.d/S86thermferm
+    ln -s /etc/rc.d/init.d/thermferm /etc/rc.d/rc6.d/K14thermferm
+  else
+    rm -f /etc/rc.d/rc{0,1,6}.d/K14thermferm /etc/rc.d/rc{3,4}.d/S86thermferm
+  fi
+fi
--- a/tools/thermferm.init	Wed May 12 21:17:59 2021 +0200
+++ /dev/null	Thu Jan 01 00:00:00 1970 +0000
@@ -1,156 +0,0 @@
-#! /bin/sh
-### BEGIN INIT INFO
-# Provides:          thermferm
-# Required-Start:    $local_fs $remote_fs $network $syslog
-# Required-Stop:     $local_fs $remote_fs $network $syslog
-# Should-Start:      mosquitto
-# Should-Stop:       mosquitto
-# Default-Start:     2 3 4 5
-# Default-Stop:      0 1 6
-# Short-Description: Thermferm beer fermenter initscript
-# Description:       This program controls temperature controlled chambers
-#                    that are used to ferment beer.
-### END INIT INFO
-
-# Author: Michiel Broek <mbroek@mbse.eu>
-
-# Do NOT "set -e"
-
-# PATH should only include /usr/* if it runs after the mountnfs.sh script
-PATH=/sbin:/usr/sbin:/bin:/usr/bin
-DESC="MBSE thermferm"
-NAME=thermferm
-DAEMON=/usr/local/bin/$NAME
-#DAEMON_ARGS="--options args"
-PIDFILE=/run/$NAME.pid
-SCRIPTNAME=/etc/init.d/$NAME
-
-# Exit if the package is not installed
-[ -x "$DAEMON" ] || exit 0
-
-# Read configuration variable file if it is present
-[ -r /etc/default/$NAME ] && . /etc/default/$NAME
-
-# Load the VERBOSE setting and other rcS variables
-. /lib/init/vars.sh
-
-# Define LSB log_* functions.
-# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
-# and status_of_proc is working.
-. /lib/lsb/init-functions
-
-#
-# Function that starts the daemon/service
-#
-do_start()
-{
-	# Return
-	#   0 if daemon has been started
-	#   1 if daemon was already running
-	#   2 if daemon could not be started
-	#start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null || return 1
-	#start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- $DAEMON_ARGS || return 2
-	$DAEMON
-	# Add code here, if necessary, that waits for the process to be ready
-	# to handle requests from services started subsequently which depend
-	# on this one.  As a last resort, sleep for some time.
-}
-
-#
-# Function that stops the daemon/service
-#
-do_stop()
-{
-	# Return
-	#   0 if daemon has been stopped
-	#   1 if daemon was already stopped
-	#   2 if daemon could not be stopped
-	#   other if a failure occurred
-	start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
-	RETVAL="$?"
-	[ "$RETVAL" = 2 ] && return 2
-	# Wait for children to finish too if this is a daemon that forks
-	# and if the daemon is only ever run from this initscript.
-	# If the above conditions are not satisfied then add some other code
-	# that waits for the process to drop all resources that could be
-	# needed by services started subsequently.  A last resort is to
-	# sleep for some time.
-	start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
-	[ "$?" = 2 ] && return 2
-	# Many daemons don't delete their pidfiles when they exit.
-	rm -f $PIDFILE
-	return "$RETVAL"
-}
-
-#
-# Function that sends a SIGHUP to the daemon/service
-#
-do_reload() {
-	#
-	# If the daemon can reload its configuration without
-	# restarting (for example, when it is sent a SIGHUP),
-	# then implement that here.
-	#
-	start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
-	return 0
-}
-
-case "$1" in
-  start)
-	[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
-	do_start
-	case "$?" in
-		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
-		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
-	esac
-	;;
-  stop)
-	[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
-	do_stop
-	case "$?" in
-		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
-		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
-	esac
-	;;
-  status)
-	status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
-	;;
-  #reload|force-reload)
-	#
-	# If do_reload() is not implemented then leave this commented out
-	# and leave 'force-reload' as an alias for 'restart'.
-	#
-	#log_daemon_msg "Reloading $DESC" "$NAME"
-	#do_reload
-	#log_end_msg $?
-	#;;
-  restart|force-reload)
-	#
-	# If the "reload" option is implemented then remove the
-	# 'force-reload' alias
-	#
-	log_daemon_msg "Restarting $DESC" "$NAME"
-	do_stop
-	case "$?" in
-	  0|1)
-		do_start
-		case "$?" in
-			0) log_end_msg 0 ;;
-			1) log_end_msg 1 ;; # Old process is still running
-			*) log_end_msg 1 ;; # Failed to start
-		esac
-		;;
-	  *)
-		# Failed to stop
-		log_end_msg 1
-		;;
-	esac
-	;;
-  *)
-	#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
-	echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
-	exit 3
-	;;
-esac
-
-:

mercurial